#include <mygba.h>
#include <stdio.h>     // We need this for sprintf()
#include "adiosgba.h"
#include "text.h"
#include "utils.h"
#include "uart.h"

MULTIBOOT

void interrupt();       // Function prototype

int main(void)
{
  ham_Init();
  ham_InitPad();
  unsigned char InChar[2];

  // Set the text up
  InitText(0xFFFF, 0x0000);
  PrintCR("Rob's adapted UART demo.");

  // Set to UART mode
  InitUART(SIO_BAUD_9600);
  
  // Setup keypad interrupt
    // Setup the keypad interrupt register
    R_CTRLINT=
        1+      // Button A
        2+      // Button B
        4+      // Button Select
        8+      // Button Start
        16+     // Button Right
        32+     // Button Left
        64+     // Button Up
        128+    // Button Down
        256+    // Button R
        512+    // Button L
        16384   // Enable interrupt flag
        ;

    // Enable keypad interrupt handling
    ham_StartIntHandler(INT_TYPE_KEY,&interrupt);

  // Just keep on looping...
  while(1) {
    // Read in a character
    InChar[0] = rcvChar();
    InChar[1] = 0;

    // If it's a CR, shift up the screen
    if(InChar[0] == 13) {
      ShiftScreen();
      ResetCursor();
    } else {
      // Otherwise, display it on the screen
      Print(InChar);
    }

    // Echo it back as well
    //sndChar(InChar[0]);
  }
}
void interrupt()
{
   switch( ~(*((volatile unsigned int *)(REG_BASE + 0x130))) & 0x3FF ){ // Mask buttons
        case 1:
            Print("A");
            sndChar('A');
            break;
        case 2:
            Print("B");
            sndChar('B');
            break;
        case 4:
            Print("s");
            sndChar('s');
            break;
        case 8:
            Print("S");
            sndChar('S');
            break;
        case 16:
            Print(">");
            sndChar('>');
            break;
        case 32:
            Print("<");
            sndChar('<');
            break;
        case 64:
            Print("^");
            sndChar('^');
            break;
        case 128:
            Print("v");
            sndChar('v');
            break;
        case 256:
            Print("R");
            sndChar('R');
            break;
        case 512:
            Print("L");
            sndChar('L');
            break;
       default:
        Print("d");
   }
   return;
}

/* END OF FILE */
