// My GBA UART library

#include "uart.h"

void InitUART(unsigned short UART)
{
  // The user should only be choosing the speed
  // Stick a character in the data register. This stops the GBA transmitting a
  // Character as soon as it goes into UART mode (?!?)
  REG_SIODATA8 = 'A';

  // Now to go into UART mode
  REG_RCNT = 0;
  REG_SIOCNT = 0;
  REG_SIOCNT = UART | /*SIO_CTS |*/ SIO_LENGTH_8 | SIO_SEND_ENABLE
             | SIO_RECV_ENABLE | SIO_USE_UART;

  // With any luck, we should now be able to talk to a PC.
}

unsigned char rcvChar(void)
{
  // Set the receive data flag to empty
  REG_SIOCNT = REG_SIOCNT | 0x0020;
  // We're using CTS so we must send a LO on the SD terminal to show we're ready
  REG_RCNT = REG_RCNT & (0x0020 ^ 0xFFFF);

  // Wait until we have a full byte (The recv data flag will go to 0)
  while(REG_SIOCNT & 0x0020);

  // Return the character in the data register
  return (unsigned char)REG_SIODATA8;
}

void sndChar(unsigned char Character)
{
  // Wait until we have a CTS signal
  while(REG_RCNT & 0x0010);
  // Bung our byte into the data register
  REG_SIODATA8 = Character;
}
