//#define  MULTIBOOT
#include <stdio.h>     // We need this for sprintf()
#include "adiosgba.h"
#include "text.h"
#include "utils.h"
#include "uart.h"

void AgbMain(void)
{
  unsigned char InChar[2];

  // Set the text up
  InitText(0xFFFF, 0x0000);  
  PrintCR("Adrian's UART demo.");

  // Set to UART mode
  InitUART(SIO_BAUD_115200);

  // Just keep on looping...
  while(1) {
    // Read in a character
    InChar[0] = rcvChar();
    InChar[1] = 0;

    // If it's a CR, shift up the screen
    if(InChar[0] == 13) {
      ShiftScreen();
      ResetCursor();
    } else {
      // Otherwise, display it on teh screen
      Print(InChar);
    }

    // Echo it back as well
    sndChar(InChar[0]);
  }
}
